/* ******************************************************************** */
/* C code generated by:							*/
/* Visual Arts Version 2.1						*/
/* Copyright 1994-95 Danny Y. Wong  All rights reserved			*/
/* Calgary, Alberta (CANADA)                        			*/
/* Partial of the code is copyright by Jaba Development			*/
/* ******************************************************************** */

#include <VisualArts.h>
#include <clib/VisualArts_protos.h>

#define ID_scrmode                        			0
#define ID_request                        			1
#define ID_font                           			2
#define ID_file                           			3

#define ASLNumGads						4

#include "ASL_func.c" 

int scrmodeObj(struct VAobject VAObject);
int requestObj(struct VAobject VAObject);
int fontObj(struct VAobject VAObject);
int fileObj(struct VAobject VAObject);

int GetPubScreen(void);
void ClosePubScreen(void);
int OpenASLWindow(char windtitle[]);
void CloseASLWindow(void);
int ASLHandler(void);
int ASLMainHandler(void);
void DrawASLObjs(void);
int main(int argc, char *argv[]);

UBYTE				*PubScrName = "Workbench";
struct DrawInfo			*ScrDrawInfo = NULL;
APTR				 VisualInfo = NULL;
struct Screen			*Scr = NULL;
struct Window			*ASLWnd = NULL;
struct Gadget			*ASLGList = NULL;
struct Gadget			*ASLGadgets[ASLNumGads];
struct IntuiMessage		 ASLMsg;
UWORD				 ASLLeft = 182;
UWORD				 ASLTop = 80;
UWORD				 ASLWidth = 202;
UWORD				 ASLHeight = 51;
struct TextAttr topaz8 = { (STRPTR)"topaz.font", 8, 0x00, 0x01 };
struct TextAttr topaz800 = { (STRPTR)"topaz.font", 8, 0x00, 0x00 };

WORD ASLGadTypes[] = {
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
	BUTTON_KIND,
};

struct NewGadget ASLNGads[] = {
	3, 1, 83, 12, (UBYTE *)"Screen",&topaz800, ID_scrmode, PLACETEXT_IN, NULL, (APTR)scrmodeObj,
	99, 20, 83, 12, (UBYTE *)"Requester",&topaz800, ID_request, PLACETEXT_IN, NULL, (APTR)requestObj,
	3, 20, 83, 12, (UBYTE *)"Font",&topaz800, ID_font, PLACETEXT_IN, NULL, (APTR)fontObj,
	99, 1, 83, 12, (UBYTE *)"File",&topaz800, ID_file, PLACETEXT_IN, NULL, (APTR)fileObj,
};

ULONG ASLNTags[] = {
	TAG_DONE,
	TAG_DONE,
	TAG_DONE,
	TAG_DONE,
};


int GetPubScreen(void)
{
  if (!(Scr = LockPubScreen(PubScrName)))
	return(1L);

  if (!(VisualInfo = GetVisualInfo(Scr, TAG_DONE)))
	return(2L);

  if (!(ScrDrawInfo = GetScreenDrawInfo(Scr)))
	return(3L);
  return(0L);
}

void ClosePubScreen(void)
{
  if (VisualInfo)
    FreeVisualInfo(VisualInfo);
  if (Scr)
    UnlockPubScreen(NULL,  Scr);
  if (ScrDrawInfo)
    FreeScreenDrawInfo(Scr,  ScrDrawInfo);
}

int OpenASLWindow(char windtitle[80])
{
  struct NewGadget	NewGad;
  struct Gadget   	*Gad;
  register UWORD i, j;
  UWORD offsetx = Scr->WBorLeft;
  UWORD offsety = Scr->WBorTop + Scr->Font->ta_YSize + 1;

  if (!(Gad = CreateContext(&ASLGList)))
  	return(1L);

  for (i=0, j=0; i < ASLNumGads; i++)
  {
    CopyMem((char *)&ASLNGads[i], (char *)&NewGad, (long)sizeof(struct NewGadget));

    NewGad.ng_VisualInfo = VisualInfo;
    NewGad.ng_LeftEdge += offsetx;
    NewGad.ng_TopEdge  += offsety;

    ASLGadgets[i] = Gad = CreateGadgetA((ULONG)ASLGadTypes[i], Gad, &NewGad,
	(struct TagItem *)&ASLNTags[j]);
    while (ASLNTags[j])
        j +=2;
    j++;
    if (!Gad)
       return(2L);
  }
  if (!(ASLWnd = OpenWindowTags(NULL,
  	WA_Left,	ASLLeft,
  	WA_Top, 	ASLTop,
  	WA_Width,	ASLWidth,
  	WA_Height,	ASLHeight + kWindowOffSetY,
  	WA_NewLookMenus, TRUE,
  	WA_IDCMP,	IDCMP_CLOSEWINDOW |  IDCMP_NEWSIZE | IDCMP_GADGETUP ,
  	WA_Flags,	WFLG_CLOSEGADGET | WFLG_DEPTHGADGET  |  WFLG_SMART_REFRESH | 
			 WFLG_RMBTRAP |  WFLG_ACTIVATE | 
			 WFLG_DRAGBAR ,
  	WA_Gadgets,	ASLGList,
  	WA_Title,	windtitle,
  	WA_ScreenTitle,	"Visual Arts V2.2 Copyright 1994-95 Danny Y. Wong  All Rights Reserved.",
  	WA_PubScreen,	Scr,
  	WA_MinWidth,	160,
  	WA_MinHeight,	50,
  	WA_MaxWidth,	640,
  	WA_MaxHeight,	200,
  	TAG_DONE)))
  	    return(3L);

  GT_RefreshWindow(ASLWnd, NULL);
  RefreshGadgets(ASLGadgets[0], ASLWnd, NULL);
  return(0L);
}

void CloseASLWindow(void)
{
  if (ASLWnd)
	CloseWindow(ASLWnd);
  if (ASLGList)
	FreeGadgets(ASLGList);
}

int ASLHandler(void)
{
  struct IntuiMessage	*msg;
  struct VAobject	VAObject;
  int running	= 1;
  int (*func)(struct VAobject VAObject);
  ULONG class;
  UWORD code;

  while (msg=GT_GetIMsg(ASLWnd->UserPort))
  {
    CopyMem((char *)msg, (char *)&ASLMsg, (long)sizeof(struct IntuiMessage));
    class = msg->Class;
    code  = msg->Code;

    VAObject.va_Window = (struct Window *)ASLWnd;
    VAObject.va_Gadget = (struct Gadget *)msg->IAddress;
    VAObject.va_IntuiMsg = (struct IntuiMessage *)msg;
    VAObject.va_Flags = 0;
    VAObject.va_UserData = 0;

    GT_ReplyIMsg(msg);
    switch(class)
    {

	  case IDCMP_NEWSIZE:
	   break;

	  case IDCMP_CLOSEWINDOW:
	     return(0);
	     break;

	  case IDCMP_GADGETUP:
	    func = (void *)((struct Gadget *)ASLMsg.IAddress)->UserData;
	    if (func != NULL)
	      running =  func(VAObject);
	    break;

    }
  }
  return(running);
}

int ASLMainHandler(void)
{
  int running = 1;
  ULONG windsig, signals;

  windsig = 1L << ASLWnd->UserPort->mp_SigBit;

  while (running == 1)
  {
    signals = Wait( windsig );
    if (signals & windsig)
    {
	  running = ASLHandler();
    }
  }
  return(running);
}

int main(int argc, char *argv[])
{
  int rc;

  if (!(GetPubScreen()))
  {
	if (!(OpenASLWindow("ASL Demo")))
	{
	  rc = ASLMainHandler();
	  CloseASLWindow();
	}
	ClosePubScreen();
  }
  return(0L);
}
